{ +--------------------------------------------------------------------------+ }
{ | StReg v0.3 * Stock registry application                                  | }
{ | Copyright (C) 2007-2016 Pozsar Zsolt <pozsarzs@gmail.com>                | }
{ | frmmain.pp                                                               | }
{ | main form                                                                | }
{ +--------------------------------------------------------------------------+ }

{
   This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by the
 Free Software Foundation, either version 3 of the License, or (at your
 option) any later version.

   This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

   You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit frmmain;
{$mode objfpc}{$H+}
interface
uses
  {$IFDEF WIN32}Windows, {$ENDIF}
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, ExtCtrls, Grids, Menus, frmmod, dos, gettext;
type
  { TForm1 }
  TForm1 = class(TForm)
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    PopupMenu1: TPopupMenu;
    StringGrid1: TStringGrid;
    TrayIcon1: TTrayIcon;
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormWindowStateChange(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: char);
    procedure TrayIcon1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 
var
  Form1: TForm1;
  userdir: string;
  df: textfile;
  b: byte;
  s: string;
  db: array[0..5,0..2047] of string;
  dby: integer;
  inum, idb, ierr, selrow: integer;
  exepath, p: shortstring;
  lang: string;

{$IFDEF UNIX}
  {$I ../config.inc}
{$ENDIF}
{$I ../common.inc}

{$IFDEF WIN32}
const
  CSIDL_PROFILE = 40;
  SHGFP_TYPE_CURRENT = 0;

  function SHGetFolderPath(hwndOwner: HWND; nFolder: Integer; hToken: THandle;
           dwFlags: DWORD; pszPath: LPTSTR): HRESULT; stdcall;
           external 'Shell32.dll' name 'SHGetFolderPathA';
{$ENDIF}

Resourcestring
  MESSAGE01='Cannot write datafile!';
  MESSAGE02='Cannot write configuration file!';
  MESSAGE03='Cannot load configuration file, using default values.';
  MESSAGE04='There is not datafile. Use StRegEdit to create new datafile!';
  MESSAGE05='category';
  MESSAGE06='name';
  MESSAGE07='qty';
  MESSAGE08='unit';
  MESSAGE09='drawer';
  MESSAGE10='chest';

implementation
{$R *.lfm}
{ TForm1 }

// On exit
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
var
  i: integer;
begin
  // save data
  AssignFile(df,userdir+DIR_DATA+'streg.csv');
  try
    rewrite(df);
    for i:=0 to 2047 do
    begin
      if length(db[0,i]+db[1,i]+db[2,i]+db[3,i]+db[4,i]+db[5,i])=0 then break;
      write(df,'"');
      for b:=0 to 5 do
      begin
        write(df,db[b,i]);
        if b<5 then write(df,'","') else writeln(df,'"');
      end;
    end;
    CloseFile(df);
  except
    ShowMessage(MESSAGE01);
  end;
  // save configuration
  AssignFile(df,userdir+DIR_CONFIG+'streg.cfg');
  try
  rewrite(df);
  if MenuItem4.Checked=true
    then writeln(df,'1')
    else writeln(df,'0');
  writeln(df,inttostr(Form1.Top));
  writeln(df,inttostr(Form1.Left));
  writeln(df,inttostr(Form1.Height));
  writeln(df,inttostr(Form1.Width));
  writeln(df,inttostr(StringGrid1.ColWidths[0]));
  writeln(df,inttostr(StringGrid1.ColWidths[1]));
  writeln(df,inttostr(StringGrid1.ColWidths[2]));
  writeln(df,inttostr(StringGrid1.ColWidths[3]));
  writeln(df,inttostr(StringGrid1.ColWidths[4]));
  writeln(df,inttostr(StringGrid1.ColWidths[5]));
  writeln(df,inttostr(StringGrid1.ColWidths[6]));
  CloseFile(df);
  except
    ShowMessage(MESSAGE02);
  end;
  // erase lock file
  AssignFile(df,userdir+DIR_CACHE+'streg.lck');
  try
    erase(df);
  except
  end;
  CanClose:=true;
end;

// Search in database
procedure TForm1.Button3Click(Sender: TObject);
var
  col, chars: byte;
  s, ss, sss: string;
  ii: integer;

begin
  Button3.Enabled:=false;
  StringGrid1.RowCount:=1;
  for ii:=0 to 2047 do
  begin
    s:='';
    for b:=0 to 5 do s:=s+db[b,ii]+' ';
      for chars:=1 to (length(s)-length(Edit1.Text)+1) do
      begin
        ss:=copy(s,chars,length(Edit1.Text));
        if uppercase(Edit1.Text)=uppercase(ss) then
        begin
          StringGrid1.RowCount:=StringGrid1.RowCount+1;
          str(ii,sss);
          StringGrid1.Cells[6,StringGrid1.RowCount-1]:=sss;
          for col:=0 to 5 do
            StringGrid1.Cells[col,StringGrid1.RowCount-1]:=db[col,ii];
        end;
      end;
  end;
  Button3.Enabled:=true;
end;

//  Modify quantity
procedure TForm1.StringGrid1DblClick(Sender: TObject);
begin
  if StringGrid1.RowCount<2 then exit;
  Form2.Show;
  Form2.SpinEdit1.Value:=0;
  selrow:=StringGrid1.Row;
  val(StringGrid1.Cells[6,StringGrid1.Row],inum,ierr);
  val(db[2,inum],idb,ierr);
  Form2.SpinEdit1.Value:=idb;
end;

// Select item with Enter
procedure TForm1.StringGrid1KeyPress(Sender: TObject; var Key: char);
begin
  if Key=#13 then StringGrid1DblClick(Sender);
end;

// Open search window
procedure TForm1.TrayIcon1Click(Sender: TObject);
begin
    Form1.WindowState:=wsNormal;
    Form1.Show;
    TrayIcon1.Visible:=False;
end;

// Load data
procedure TForm1.FormCreate(Sender: TObject);
{$IFDEF WIN32}
var
  buffer: pchar;
  size: integer;
{$ENDIF}

{$IFDEF WIN32}
  function GetUserProfile: string;
  var
    Buffer: array[0..MAX_PATH] of Char;
  begin
    FillChar(Buffer, SizeOf(Buffer), 0);
    SHGetFolderPath(0, CSIDL_PROFILE, 0, SHGFP_TYPE_CURRENT, Buffer);
    Result := String(PChar(@Buffer));
  end;
{$ENDIF}

begin
  Form1.Caption:=APPNAME+' v'+VERSION;
 {$IFDEF WIN32}
  fsplit(paramstr(0),exepath,p,p);
 {$ENDIF}
 {$IFDEF UNIX}
  s:=getenv('LANG');
 {$ENDIF}
 {$IFDEF WIN32}
  size:=getLocaleinfo (LOCALE_USER_DEFAULT, LOCALE_SABBREVLANGNAME, nil, 0);
  getmem(buffer, size);
  try
    getlocaleinfo (LOCALE_USER_DEFAULT, LOCALE_SABBREVLANGNAME, Buffer, Size);
    s:=string(buffer);
  finally
    freemem(buffer);
  end;
 {$ENDIF}
  if length(s)=0 then s:='en';
  lang:=lowercase(s[1..2]);
 {$IFDEF UNIX}{$IFDEF UseFHS}
  translateresourcestrings(MYI18PATH+LANG+'/LC_MESSAGES/streg.mo');
 {$ELSE}
  translateresourcestrings(EXEPATH+'languages/'+LANG+'/streg_'+LANG+'.mo');
 {$ENDIF}{$ENDIF}
 {$IFDEF WIN32}
  translateresourcestrings(EXEPATH+'languages\'+LANG+'\streg_'+LANG+'.mo');
 {$ENDIF}
  StringGrid1.Cells[0,0]:=MESSAGE05;
  StringGrid1.Cells[1,0]:=MESSAGE06;
  StringGrid1.Cells[2,0]:=MESSAGE07;
  StringGrid1.Cells[3,0]:=MESSAGE08;
  StringGrid1.Cells[4,0]:=MESSAGE09;
  StringGrid1.Cells[5,0]:=MESSAGE10;
{$IFDEF UNIX}
  userdir:=getenvironmentvariable('HOME');
{$ENDIF}
{$IFDEF WIN32}
  userdir:=getuserprofile;
{$ENDIF}
  ForceDirectories(userdir+DIR_CACHE);
  ForceDirectories(userdir+DIR_CONFIG);
  ForceDirectories(userdir+DIR_DATA);

  // create lock file
  AssignFile(df,userdir+DIR_CACHE+'streg.lck');
  try
    rewrite(df);
    CloseFile(df);
  except
  end;
  // load configuration
  AssignFile(df,frmmain.userdir+DIR_CONFIG+'streg.cfg');
  try
  reset(df);
  readln(df,s);
  if s[1]='0' then MenuItem4.Checked:=false else MenuItem4.Checked:=true;
  if s[1]='0' then StringGrid1.GridLineWidth:=0 else StringGrid1.GridLineWidth:=1;
  readln(df,s); Form1.Top:=strtoint(s);
  readln(df,s); Form1.Left:=strtoint(s);
  readln(df,s); Form1.Height:=strtoint(s);
  readln(df,s); Form1.Width:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[0]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[1]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[2]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[3]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[4]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[5]:=strtoint(s);
  readln(df,s); StringGrid1.ColWidths[6]:=strtoint(s);
  CloseFile(df);
  except
    ShowMessage(MESSAGE03);
  end;
  // load data
  AssignFile(df,userdir+DIR_DATA+'streg.csv');
  try
    reset(df);
    dby:=0;
    repeat
      readln(df,s);
      for b:=2 to length(s) do if s[b]<>'"' then db[0,dby]:=db[0,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then db[1,dby]:=db[1,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then db[2,dby]:=db[2,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then db[3,dby]:=db[3,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then db[4,dby]:=db[4,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then db[5,dby]:=db[5,dby]+s[b] else break;
      s:='';
      dby:=dby+1;
    until eof(df);
    Closefile(df);
  except
    ShowMessage(MESSAGE04);
  end;
end;

// Optimal  fill
procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  StringGrid1.AutoSizeColumns;
end;

// Auto fill
procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  StringGrid1.AutoFillColumns:=true;StringGrid1.AutoFillColumns:=false;
end;

// Grid on/off
procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  MenuItem4.Checked:=not MenuItem4.Checked;
  if MenuItem4.Checked=true
    then StringGrid1.GridLineWidth:=1
    else StringGrid1.GridLineWidth:=0;
end;

// Set default sizes
procedure TForm1.MenuItem5Click(Sender: TObject);
begin
  Form1.Height:=188;
  Form1.Width:=371;
  StringGrid1.ColWidths[0]:=68;
  StringGrid1.ColWidths[1]:=121;
  StringGrid1.ColWidths[2]:=30;
  StringGrid1.ColWidths[3]:=31;
  StringGrid1.ColWidths[4]:=58;
  StringGrid1.ColWidths[5]:=53;
  StringGrid1.ColWidths[6]:=2;
end;

// Other events
procedure TForm1.FormWindowStateChange(Sender: TObject);
begin
  if Form1.WindowState=wsMinimized then
  begin
    Form1.Hide;
    TrayICon1.Visible:=true;
  end;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if length(Edit1.Text)>1
    then Button3.Enabled:=true
    else Button3.Enabled:=false;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: char);
begin
  if (Key=#13) and (length(Edit1.Text)>1) then Button3Click(Sender);
end;

end.

