{ +--------------------------------------------------------------------------+ }
{ | StReg v0.3 * Stock registry application                                  | }
{ | Copyright (C) 2007-2016 Pozsar Zsolt <pozsarzs@gmail.com>                | }
{ | frmmain.pp                                                               | }
{ | main form                                                                | }
{ +--------------------------------------------------------------------------+ }

{
   This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by the
 Free Software Foundation, either version 3 of the License, or (at your
 option) any later version.

   This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.

   You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit frmmain; 
{$mode objfpc}{$H+}
interface
uses
  {$IFDEF WINDOWS}Windows,{$ENDIF} Classes, SysUtils, FileUtil, LResources,
  Forms, Controls, Graphics, Dialogs, Grids, StdCtrls, Menus, dos, gettext;
type
  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    MenuItem1: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    PopupMenu1: TPopupMenu;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 
var
  Form1: TForm1; 
  userdir: string;
  df: textfile;
  b: byte;
  s: string;
  i: integer;
  exepath, p: shortstring;
  lang: string;

{$IFDEF UNIX}
  {$I ../config.inc}
{$ENDIF}
{$I ../common.inc}

{$IFDEF WIN32}
const
  CSIDL_PROFILE = 40;
  SHGFP_TYPE_CURRENT = 0;

  function SHGetFolderPath(hwndOwner: HWND; nFolder: Integer; hToken: THandle;
           dwFlags: DWORD; pszPath: LPTSTR): HRESULT; stdcall;
           external 'Shell32.dll' name 'SHGetFolderPathA';
{$ENDIF}

Resourcestring
  MESSAGE01='There is not datafile. Creating a new!';
  MESSAGE02='Cannot write datafile!';
  MESSAGE03='category';
  MESSAGE04='name';
  MESSAGE05='qty';
  MESSAGE06='unit';
  MESSAGE07='drawer';
  MESSAGE08='chest';
  MESSAGE09='Do you close application?';
  MESSAGE10='Close StReg application before start StRegEdit!';

implementation
{$R *.lfm}
{ TForm1 }

// OnCreate event
procedure TForm1.FormCreate(Sender: TObject);
var
  dby: integer;
{$IFDEF WIN32}
  buffer: pchar;
  size: integer;
{$ENDIF}

{$IFDEF WIN32}
  function GetUserProfile: string;
  var
    Buffer: array[0..MAX_PATH] of Char;
  begin
    FillChar(Buffer, SizeOf(Buffer), 0);
    SHGetFolderPath(0, CSIDL_PROFILE, 0, SHGFP_TYPE_CURRENT, Buffer);
    Result := String(PChar(@Buffer));
  end;
{$ENDIF}

begin
  Form1.Caption:=APPNAME+' v'+VERSION;
 {$IFDEF WIN32}
  fsplit(paramstr(0),exepath,p,p);
 {$ENDIF}
 {$IFDEF UNIX}
  s:=getenv('LANG');
 {$ENDIF}
 {$IFDEF WIN32}
  size:=getLocaleinfo (LOCALE_USER_DEFAULT, LOCALE_SABBREVLANGNAME, nil, 0);
  getmem(buffer, size);
  try
    getlocaleinfo (LOCALE_USER_DEFAULT, LOCALE_SABBREVLANGNAME, Buffer, Size);
    s:=string(buffer);
  finally
    freemem(buffer);
  end;
 {$ENDIF}
  if length(s)=0 then s:='en';
  lang:=lowercase(s[1..2]);
 {$IFDEF UNIX}{$IFDEF UseFHS}
  translateresourcestrings(MYI18PATH+LANG+'/LC_MESSAGES/stregedit.mo');
 {$ELSE}
  translateresourcestrings(EXEPATH+'languages/'+LANG+'/stregedit_'+LANG+'.mo');
 {$ENDIF}{$ENDIF}
 {$IFDEF WIN32}
  translateresourcestrings(EXEPATH+'languages\'+LANG+'\stregedit_'+LANG+'.mo');
 {$ENDIF}
  StringGrid1.Cells[0,0]:=MESSAGE03;
  StringGrid1.Cells[1,0]:=MESSAGE04;
  StringGrid1.Cells[2,0]:=MESSAGE05;
  StringGrid1.Cells[3,0]:=MESSAGE06;
  StringGrid1.Cells[4,0]:=MESSAGE07;
  StringGrid1.Cells[5,0]:=MESSAGE08;
{$IFDEF UNIX}
  userdir:=getenvironmentvariable('HOME');
{$ENDIF}
{$IFDEF WIN32}
  userdir:=getuserprofile;
{$ENDIF}
  ForceDirectories(userdir+DIR_CACHE);
  ForceDirectories(userdir+DIR_CONFIG);
  ForceDirectories(userdir+DIR_DATA);
  // check lock file
  s:=FSearch('streg.lck',userdir+DIR_CACHE);
  if length(s)<>0 then
  begin
    messagedlg(MESSAGE10,mtInformation,[mbOK],0);
    Application.Terminate;
  end;
  // load data
  AssignFile(df,userdir+DIR_DATA+'streg.csv');
  try
    reset(df);
    dby:=1;
    repeat
      readln(df,s);
      StringGrid1.RowCount:=StringGrid1.RowCount+1;
      for b:=2 to length(s) do if s[b]<>'"' then StringGrid1.Cells[0,dby]:=StringGrid1.Cells[0,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then StringGrid1.Cells[1,dby]:=StringGrid1.Cells[1,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then StringGrid1.Cells[2,dby]:=StringGrid1.Cells[2,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then StringGrid1.Cells[3,dby]:=StringGrid1.Cells[3,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then StringGrid1.Cells[4,dby]:=StringGrid1.Cells[4,dby]+s[b] else break;
      for b:=b+3 to length(s) do if s[b]<>'"' then StringGrid1.Cells[5,dby]:=StringGrid1.Cells[5,dby]+s[b] else break;
      s:='';
      dby:=dby+1;
    until eof(df);
    Closefile(df);
  except
    ShowMessage(MESSAGE01);
  end;
end;

// Sort by category
procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  if StringGrid1.RowCount>1 then StringGrid1.SortColRow(true,0);
end;

// Sort by name
procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  if StringGrid1.RowCount>1 then StringGrid1.SortColRow(true,1);
end;

// Sort by drawer
procedure TForm1.MenuItem4Click(Sender: TObject);
begin
  if StringGrid1.RowCount>1 then StringGrid1.SortColRow(true,4);
end;

// Auto fill
procedure TForm1.MenuItem7Click(Sender: TObject);
begin
  StringGrid1.AutoFillColumns:=true;StringGrid1.AutoFillColumns:=false;
end;

// Auto column size
procedure TForm1.MenuItem8Click(Sender: TObject);
begin
  StringGrid1.AutoSizeColumns;
end;

// Add new item
procedure TForm1.Button1Click(Sender: TObject);
begin
  StringGrid1.RowCount:=StringGrid1.RowCount+1;
end;

// Delete item
procedure TForm1.Button2Click(Sender: TObject);
begin
  if StringGrid1.RowCount>1 then StringGrid1.DeleteColRow(false,StringGrid1.Row);
end;

// Save and exit
procedure TForm1.Button3Click(Sender: TObject);
begin
  // save data
  AssignFile(df,userdir+DIR_DATA+'streg.csv');
  try
    rewrite(df);
    for i:=1 to StringGrid1.RowCount-1 do
    begin
      write(df,'"');
      for b:=0 to 5 do
      begin
        write(df,StringGrid1.Cells[b,i]);
        if b<5 then write(df,'","') else writeln(df,'"');
      end;
    end;
    CloseFile(df);
  except
    ShowMessage(MESSAGE02);
    exit;
  end;
  Application.Terminate;
end;

// Exit
procedure TForm1.Button4Click(Sender: TObject);
begin
  Form1.Close;
end;

// On exit;
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if messagedlg(MESSAGE09,mtConfirmation,[mbYes,mbNo],0)=mrYes
    then CanClose:=true
    else CanClose:=false;
end;

end.


